-- scope stuff
qualityoflife = qualityoflife or {};
local q = qualityoflife;

q.modules = q.modules or {};
q.modules["QoL_ClassicThreat-TBC"] = q.modules["QoL_ClassicThreat-TBC"] or {};
local c = q.modules["QoL_ClassicThreat-TBC"];

local labelWidth, sliderWidth = 180, 170;

local btnResetAll;

local lblHeaderGeneral, lblHeaderUnitFrames;

local chShowBarFrame;

local lblPlayerAccuracy, sldPlayerAccuracy, lblPlayerAccuracyHint;
local chShowPlayer, chShowPlayerTankMode, chShowPlayerPet;
local chShowTarget, chShowTargetTarget;
local chShowParty;
local lblPartyAccuracy, sldPartyAccuracy, lblPartyAccuracyHint;
local chShowRaid, chShowRaidOutline;
local lblRaidAccuracy, sldRaidAccuracy, lblRaidAccuracyHint;

local lblHeaderNamePlates;
local chShowNamePlates;

local spacings, spacingIndex = {};

local function SetDefaultValues()
    QOL_OPTIONS = QOL_OPTIONS or {};
    QOL_OPTIONS[c.name] = QOL_OPTIONS[c.name] or {};

    QOL_OPTIONS[c.name][c.BARFRAME] = QOL_OPTIONS[c.name][c.BARFRAME] or {};
    QOL_OPTIONS[c.name][c.BARFRAME]["left"] = QOL_OPTIONS[c.name][c.BARFRAME]["left"] or 500;
    QOL_OPTIONS[c.name][c.BARFRAME]["bottom"] = QOL_OPTIONS[c.name][c.BARFRAME]["bottom"] or 500;
    QOL_OPTIONS[c.name][c.BARFRAME]["width"] = QOL_OPTIONS[c.name][c.BARFRAME]["width"] or 200;
    QOL_OPTIONS[c.name][c.BARFRAME]["height"] = QOL_OPTIONS[c.name][c.BARFRAME]["height"] or 100;
    QOL_OPTIONS[c.name][c.BARFRAME]["mode"] = QOL_OPTIONS[c.name][c.BARFRAME]["mode"] or c.BARFRAME_MODE_UNIT;
    QOL_OPTIONS[c.name][c.BARFRAME]["unit"] = QOL_OPTIONS[c.name][c.BARFRAME]["unit"] or "player";
    if QOL_OPTIONS[c.name][c.BARFRAME][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.BARFRAME][c.OPT_ENABLED] = true;
    end

    QOL_OPTIONS[c.name][c.PROFILES] = QOL_OPTIONS[c.name][c.PROFILES] or {};
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT] = QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT] or {};

    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER] or {};
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET] or {};

    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET] or {};
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET] or {};

    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY] = QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY] or {};
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT] or {};

    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE] =
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE] or {};

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED] = true;
    end
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY] = 8;
    end

    -- tank mode is character based
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE] = QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE] or {};
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()] = false;
    end

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET][c.OPT_ENABLED] = true;
    end

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET][c.OPT_ENABLED] = true;
    end
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET][c.OPT_ENABLED] = true;
    end

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ENABLED] = true;
    end
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY] = 8;
    end

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED] = true;
    end
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY] = 4;
    end
    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_OUTLINE] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_OUTLINE] = false;
    end

    if QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE][c.OPT_ENABLED] == nil then
        QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE][c.OPT_ENABLED] = false;
    end
end

function c:InitOptions()
    -- options
    c.OPT_VISITED = "OPT_VISITED";

    -- profiles
    c.PROFILES = "PROFILES";
    c.PROFILE_DEFAULT = "PROFILE_DEFAULT";

    -- frames
    c.FRAME_PLAYER = "FRAME_PLAYER";
    c.FRAME_PLAYER_PET = "FRAME_PLAYER_PET";
    c.FRAME_TARGET = "FRAME_TARGET";
    c.FRAME_TARGET_TARGET = "FRAME_TARGET_TARGET";
    c.FRAME_PARTY = "FRAME_PARTY";
    c.FRAME_RAID_COMPACT = "FRAME_RAID_COMPACT";
    c.FRAME_NAMEPLATE = "FRAME_NAMEPLATE";

    c.BARFRAME = "BARFRAME";
    c.BARFRAME_MODE = "BARFRAME_MODE";
    c.BARFRAME_MODE_UNIT = "BARFRAME_MODE_UNIT";
    c.BARFRAME_MODE_RAID = "BARFRAME_MODE_RAID";

    -- options
    c.OPT_ENABLED = "OPT_ENABLED";
    c.OPT_ACCURACY = "OPT_ACCURACY";
    c.OPT_OUTLINE = "OPT_OUTLINE";
    c.OPT_TANK_MODE = "OPT_TANK_MODE";

    SetDefaultValues();

    -- optionsPanel init
    if not c.optionsPanel then
        c.optionsPanel = CreateFrame("Frame", "QoLOptionsFrame_ClassicThreat", q.optionsPanel);
        c.optionsPanel.name = "ClassicThreat";
        c.optionsPanel.parent = q.optionsPanel.name;
        c.optionsPanel.okay = function()
            c:SaveSettingsChanges();
        end;
        c.optionsPanel.cancel = function()
            c:RevertSettingsChanges();
        end;
        InterfaceOptions_AddCategory(c.optionsPanel);
        c.optionsPanel:SetScript("OnShow", function()
            if c.initFinished then
                c:ShowOptionsPanel();
                QOL_OPTIONS[c.name][c.OPT_VISITED] = true;
                c.optionsPanel.oldValues[c.OPT_VISITED] = true;
            end
        end);
        c.optionsPanel:SetScript("OnHide", function()
            if c.initFinished then
                c:HideFrames(); -- reset frames in case frames were visible at this point
            end
        end);
        q:HandleElvUi(c.optionsPanel);

        -- workaround for lazy profile loading (addon loading timing problem)
        _G["InterfaceOptionsFrameTab2"]:HookScript("OnClick", function()
            c:ShowOptionsPanel();
        end);

        c:ShowOptionsPanel();
    end

    return true;
end

local function SetOptionEnabled(element, value)
    element:SetEnabled(value);
    if value then
        element.fontString:SetVertexColor(unpack(element.fontString.defaultColor));
    else
        element.fontString:SetVertexColor(0.7, 0.7, 0.7);
    end
end

function c:ShowOptionsPanel()
    spacingIndex, c.optionsPanel.oldValues = 1, q:Deepcopy(QOL_OPTIONS[c.name]);

    -- GENERAL header
    if not lblHeaderGeneral then
        lblHeaderGeneral = q:CreateOptionsHeader(c.optionsPanel, q:GetText("General"));
        lblHeaderGeneral.fontString:SetVertexColor(1, 1, 1);
    end

    -- bar frame
    if not chShowBarFrame then
        chShowBarFrame = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show bar frame"), function(self)
            QOL_OPTIONS[c.name][c.BARFRAME][c.OPT_ENABLED] = self:GetChecked();
        end);
    end
    chShowBarFrame:SetChecked(QOL_OPTIONS[c.name][c.BARFRAME][c.OPT_ENABLED]);

    -- UNIT FRAMES header
    if not lblHeaderUnitFrames then
        lblHeaderUnitFrames = q:CreateOptionsHeader(c.optionsPanel, q:GetText("Unit Frames"));
        lblHeaderUnitFrames.fontString:SetVertexColor(1, 1, 1);
    end

    -- player enabled
    if not chShowPlayer then
        chShowPlayer = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show my threat (\"player\")"), function(self)
            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED] = self:GetChecked();
            SetOptionEnabled(chShowPlayerTankMode, QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED]);
        end);
    end
    chShowPlayer:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED]);

    -- player tank mode
    if not chShowPlayerTankMode then
        chShowPlayerTankMode = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText(
            "Tank Mode (shows lowest threat except target instead of highest threat)"), function(self)
            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()] = self:GetChecked();
        end, 24);
    end
    chShowPlayerTankMode:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()]);
    SetOptionEnabled(chShowPlayerTankMode, QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ENABLED]);

    -- player pet enabled
    if not chShowPlayerPet then
        chShowPlayerPet = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show my pets threat (\"playerpet\")"),
            function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET][c.OPT_ENABLED] = self:GetChecked();
            end);
    end
    chShowPlayerPet:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER_PET][c.OPT_ENABLED]);

    -- player accuracy
    if not lblPlayerAccuracy then
        lblPlayerAccuracy = q:CreateOptionsLabel(c.optionsPanel, q:GetText("Accuracy: %s / 8",
            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY]), 0, true);
    end
    if not sldPlayerAccuracy then
        sldPlayerAccuracy = q:CreateOptionsSlider(c.optionsPanel, 1, 8, function(self)
            if c.initFinished then
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY] = self:GetValue();
                lblPlayerAccuracy:SetText(q:GetText("Accuracy: %s / 8",
                    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY]));
            end
        end, 120, true, sliderWidth, 1, q:GetText("min"), q:GetText("max"));
    end
    sldPlayerAccuracy:SetValue(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_ACCURACY]);
    if not lblPlayerAccuracyHint then
        lblPlayerAccuracyHint = q:CreateOptionsLabel(c.optionsPanel,
            q:GetText("(Decrease if you notice lag during combat)"), 320);
    end

    c:InsertSpacing();
    c:InsertSpacing();

    -- target enabled
    if not chShowTarget then
        chShowTarget = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show my threat on target (\"target\")"),
            function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET][c.OPT_ENABLED] = self:GetChecked();
            end);
    end
    chShowTarget:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET][c.OPT_ENABLED]);

    -- target target enabled
    if not chShowTargetTarget then
        chShowTargetTarget = q:CreateOptionsCheckbox(c.optionsPanel,
            q:GetText("Show target-target threat (\"targettarget\")"), function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET][c.OPT_ENABLED] = self:GetChecked();
            end);
    end
    chShowTargetTarget:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_TARGET_TARGET][c.OPT_ENABLED]);

    c:InsertSpacing();
    c:InsertSpacing();

    -- party enabled
    if not chShowParty then
        chShowParty = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show threat for party members (\"partyN\")"),
            function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ENABLED] = self:GetChecked();
            end);
    end
    chShowParty:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ENABLED]);

    -- party accuracy
    if not lblPartyAccuracy then
        lblPartyAccuracy = q:CreateOptionsLabel(c.optionsPanel, q:GetText("Accuracy: %s / 8",
            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY]), 0, true);
    end
    if not sldPartyAccuracy then
        sldPartyAccuracy = q:CreateOptionsSlider(c.optionsPanel, 1, 8, function(self)
            if c.initFinished then
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY] = self:GetValue();
                lblPartyAccuracy:SetText(q:GetText("Accuracy: %s / 8",
                    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY]));
            end
        end, 120, true, sliderWidth, 1, q:GetText("min"), q:GetText("max"));
    end
    sldPartyAccuracy:SetValue(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PARTY][c.OPT_ACCURACY]);
    if not lblPartyAccuracyHint then
        lblPartyAccuracyHint = q:CreateOptionsLabel(c.optionsPanel,
            q:GetText("(Decrease if you notice lag during combat)"), 320);
    end

    c:InsertSpacing();
    c:InsertSpacing();

    -- raid enabled
    if not chShowRaid then
        chShowRaid = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show threat for raid members (\"raidN\")"),
            function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED] = self:GetChecked();
                SetOptionEnabled(chShowRaidOutline,
                    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED]);
            end);
    end
    chShowRaid:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED]);

    -- raid outline
    if not chShowRaidOutline then
        chShowRaidOutline = q:CreateOptionsCheckbox(c.optionsPanel,
            q:GetText("Outline for raid numbers (improves readability)"), function(self)
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_OUTLINE] = self:GetChecked();
            end, 24);
    end
    chShowRaidOutline:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_OUTLINE]);
    SetOptionEnabled(chShowRaidOutline, QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ENABLED]);

    -- raid accuracy
    if not lblRaidAccuracy then
        lblRaidAccuracy = q:CreateOptionsLabel(c.optionsPanel, q:GetText("Accuracy: %s / 8",
            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY]), 0, true);
    end
    if not sldRaidAccuracy then
        sldRaidAccuracy = q:CreateOptionsSlider(c.optionsPanel, 1, 8, function(self)
            if c.initFinished then
                QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY] = self:GetValue();
                lblRaidAccuracy:SetText(q:GetText("Accuracy: %s / 8",
                    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY]));
            end
        end, 120, true, sliderWidth, 1, q:GetText("min"), q:GetText("max"));
    end
    sldRaidAccuracy:SetValue(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_RAID_COMPACT][c.OPT_ACCURACY]);
    if not lblRaidAccuracyHint then
        lblRaidAccuracyHint = q:CreateOptionsLabel(c.optionsPanel,
            q:GetText("(Decrease if you notice lag during combat)"), 320);
    end

    -- name plates header
    -- if not lblHeaderNamePlates then
    --    lblHeaderNamePlates = q:CreateOptionsHeader(c.optionsPanel, q:GetText("Name Plates (experimental)"));
    -- end

    -- name plates enabled
    -- if not chShowNamePlates then
    --    chShowNamePlates = q:CreateOptionsCheckbox(c.optionsPanel, q:GetText("Show threat on name plates (\"nameplateN\")"),
    --        function(self)
    --            QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE][c.OPT_ENABLED] = self:GetChecked();
    --        end);
    -- end
    -- chShowNamePlates:SetChecked(QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_NAMEPLATE][c.OPT_ENABLED]);

    -- reset all
    if not btnResetAll then
        btnResetAll = q:CreateOptionsButton(c.optionsPanel, q:GetText("Reset all"), function()
            c:ShowResetDialog();
        end);
        btnResetAll:ClearAllPoints();
        btnResetAll:SetPoint("BOTTOMLEFT", 15, 15);
    end

    C_Timer.After(0.25, function()

    end);
end

function c:InsertSpacing()
    if not spacings[spacingIndex] then
        spacings[spacingIndex] = q:CreateOptionsSpacing(c.optionsPanel);
    end
    spacingIndex = spacingIndex + 1;
end

function c:RevertSettingsChanges()
    QOL_OPTIONS[c.name] = c.optionsPanel.oldValues;
end

function c:SaveSettingsChanges()
    c.optionsPanel.oldValues = q:Deepcopy(QOL_OPTIONS[c.name]);
    c:ToggleBarFrame(QOL_OPTIONS[c.name][c.BARFRAME][c.OPT_ENABLED]);
end

function c:IsTankModeEnabled()
    return QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()];
end

function c:ToggleTankMode()
    local newVal, text = not QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()];
    QOL_OPTIONS[c.name][c.PROFILES][c.PROFILE_DEFAULT][c.FRAME_PLAYER][c.OPT_TANK_MODE][q:GetPlayerName()] = newVal;

    if newVal then
        text = q:GetText("enabled");
        c:GetPlayerThreatFrame().tankModeFrame.text:SetText("|TInterface\\GROUPFRAME\\UI-GROUP-MAINTANKICON:14:14:0:0|t");
    else
        text = q:GetText("disabled");
        c:GetPlayerThreatFrame().tankModeFrame.text:SetText("");
    end
    c:GetPlayerThreatFrame():Hide();
    c:Println(q:GetText("Tank mode %s.", text));

    return newVal;
end